diff -Nur bcm963xx_router.orig/hostTools/scripts/defconfig-bcm.template bcm963xx_router/hostTools/scripts/defconfig-bcm.template
--- bcm963xx_router.orig/hostTools/scripts/defconfig-bcm.template	2006-01-25 04:56:29.000000000 +0100
+++ bcm963xx_router/hostTools/scripts/defconfig-bcm.template	2007-12-17 09:02:49.000000000 +0100
@@ -197,7 +197,7 @@
 # CONFIG_CPU_ADVANCED is not set
 CONFIG_CPU_HAS_LLSC=y
 CONFIG_CPU_HAS_SYNC=y
-# CONFIG_PREEMPT is not set
+CONFIG_PREEMPT=y
 # CONFIG_DEBUG_SPINLOCK_SLEEP is not set
 
 #
diff -Nur bcm963xx_router.orig/Makefile bcm963xx_router/Makefile
--- bcm963xx_router.orig/Makefile	2006-01-25 04:56:29.000000000 +0100
+++ bcm963xx_router/Makefile	2007-12-17 09:02:49.000000000 +0100
@@ -98,7 +98,7 @@
 NTC=1
 ifeq ($(strip $(NTC)),1)
 #TOOLCHAIN=/opt/toolchains/uclibc-crosstools
-TOOLCHAIN=/opt/toolchains_3_04/uclibc-crosstools
+TOOLCHAIN=/opt/toolchains/uclibc-crosstools
 CROSS_COMPILE = $(TOOLCHAIN)/bin/mips-linux-uclibc-
 else
 TOOLCHAIN=/opt/toolchains/uclibc
@@ -283,6 +283,7 @@
         $(OPENSOURCE_DIR)/ftpd \
         $(OPENSOURCE_DIR)/libcreduction \
         $(OPENSOURCE_DIR)/busybox \
+        $(OPENSOURCE_DIR)/thttpd \
 	$(OPENSOURCE_DIR)/openssl
 
 #In future, we need to add soap when it
@@ -295,6 +296,7 @@
         $(BROADCOM_DIR)/wlctl \
         $(BROADCOM_DIR)/vodsl \
         $(BROADCOM_DIR)/atmctl \
+        $(BROADCOM_DIR)/dropbear \
         $(BROADCOM_DIR)/adslctl \
         $(BROADCOM_DIR)/netctl \
         $(BROADCOM_DIR)/dnsprobe \
@@ -318,9 +320,9 @@
 SUBDIRS = $(foreach dir, $(SUBDIRS_APP), $(shell if [ -d "$(dir)" ]; then echo $(dir); fi))
 
 OPENSOURCE_APPS = pvc2684ctl pvc2684d brctl pppd udhcp iptables ebtables \
-                  reaim siproxd snmp zebra bftpd busybox gdbserver openssl
+                  reaim siproxd snmp zebra bftpd busybox gdbserver openssl thttpd
 
-BROADCOM_APPS = cfm upnp nas wlctl vodsl atmctl adslctl netctl dnsprobe \
+BROADCOM_APPS = cfm upnp nas wlctl vodsl atmctl dropbear adslctl netctl dnsprobe \
                 igmp dhcpr diagapp sntp ddnsd ilmi ippd hotplug ethctl epittcp\
                 fwscheduler urlfilter traffic_ctl pcscan ntp smdog ledtest
 
@@ -752,6 +754,13 @@
 atmctl:
 endif
 
+ifneq ($(strip $(BUILD_DROPBEAR)),)
+dropbear:
+	$(MAKE) -C $(BROADCOM_DIR)/dropbear $(BUILD_DROPBEAR)
+else
+dropbear:
+endif
+
 ifneq ($(strip $(BUILD_ADSLCTL)),)
 adslctl:
 	$(MAKE) -C $(BROADCOM_DIR)/adslctl $(BUILD_ADSLCTL)
@@ -780,6 +789,13 @@
 busybox:
 endif
 
+ifneq ($(strip $(BUILD_THTTPD)),)
+thttpd:
+	$(MAKE) -C $(OPENSOURCE_DIR)/thttpd install
+else
+thttpd:
+endif
+
 ifneq ($(strip $(BUILD_LIBCREDUCTION)),)
 libcreduction:
 	$(MAKE) -C $(OPENSOURCE_DIR)/libcreduction install
@@ -936,15 +952,15 @@
 ###########################################	
 
 export  BRCM_VERSION BRCM_RELEASE BRCM_EXTRAVERSION BRCM_RELEASETAG BRCM_BOARD RUN_NOISE \
-	INC_KERNEL_BASE KERNEL_DIR BRCMDRIVERS_DIR USERAPPS_DIR HOSTTOOLS_DIR TARGETS_DIR DEFAULTCFG_DIR XCHANGE_DIR FSSRC_DIR BUSYBOX_DIR \
+	INC_KERNEL_BASE KERNEL_DIR BRCMDRIVERS_DIR USERAPPS_DIR HOSTTOOLS_DIR TARGETS_DIR DEFAULTCFG_DIR XCHANGE_DIR FSSRC_DIR BUSYBOX_DIR THTTPD_DIR \
 	PROFILE_DIR INSTALL_DIR LINUXDIR INC_BRCMDRIVER_PUB_PATH INC_BRCMDRIVER_PRIV_PATH INC_BRCMBOARDPARMS_PATH INC_ENDPOINT_PATH INC_ADSLDRV_PATH BROADCOM_CFM_DIR INC_BRCMCFM_PATH BRCM_KERNEL_ROOTFS BRCMAPPS \
 	BRCM_UCLIBC CROSS_COMPILE TOOLCHAIN AS LD CC CXX AR NM STRIP SSTRIP OBJCOPY OBJDUMP RANLIB LIB_PATH LIBCDIR LIBDIR  \
 	BUILD_BR2684CTL BUILD_PVC2684CTL BUILD_RT2684D BUILD_BRCTL BUILD_CFM BUILD_CFM_CLI BUILD_IPTABLES BUILD_EBTABLES BUILD_VODSL BUILD_SIPROXD \
 	BRCM_APP_PHONE BUILD_SOAP BUILD_SOAP_VER BRCM_DSP_CODEC_G711 BRCM_DSP_CODEC_G723 BRCM_DSP_CODEC_G726 BRCM_DSP_CODEC_G729 \
    BRCM_DSP_CODEC_G7xx BRCM_DSP_PCM BRCM_DSP_HYBRID BRCM_DSP_HYBRID_EXT BRCM_DSP_APM_FXO BRCM_DSP_APM_FXO_EXT BRCM_DSP_HYBRID_FXO \
    BRCM_DSP_HYBRID_FXO_EXT BRCM_DSP_CODEC_T38_EXT BRCM_DSP_CODEC_T38_INT BRCM_DSP_HAL BRCM_DSP_HAL_EXTENSION  XCHANGE_DSP_APP_EXTENSION BRCM_VOICE_COUNTRY_JAPAN BRCM_VOICE_GLOBAL_CFLAGS \
-	BUILD_PPPD BUILD_REAIM BUILD_GDBSERVER BUILD_UDHCP BUILD_DHCPR BUILD_UPNP BUILD_SNMP BUILD_NAS BUILD_WLCTL BUILD_BUSYBOX BUILD_DNSPROBE BUILD_SLACTEST BUILD_VCONFIG BUILD_ETHWAN  BUILD_NTP BUILD_OPENSSL \
-	BUILD_ZEBRA BUILD_ATMCTL BUILD_ADSLCTL BUILD_NETCTL BUILD_IGMP BRCM_PTHREADS BUILD_DIAGAPP \
+	BUILD_PPPD BUILD_REAIM BUILD_GDBSERVER BUILD_UDHCP BUILD_DHCPR BUILD_UPNP BUILD_SNMP BUILD_NAS BUILD_WLCTL BUILD_BUSYBOX BUILD_THTTPD BUILD_DNSPROBE BUILD_SLACTEST BUILD_VCONFIG BUILD_ETHWAN  BUILD_NTP BUILD_OPENSSL \
+	BUILD_ZEBRA BUILD_ATMCTL BUILD_DROPBEAR BUILD_ADSLCTL BUILD_NETCTL BUILD_IGMP BRCM_PTHREADS BUILD_DIAGAPP \
 	BUILD_CFM_TELNETD BUILD_CFM_SSHD BUILD_SSHD_MIPS_GENKEY BUILD_FTPD BRCM_DRIVER_PCI \
 	BRCM_PSI_VERSION WEB_POPUP BUILD_DIR BUILD_DDNSD BUILD_SNTP BUILD_TOD BUILD_IPPD BUILD_VCONFIG JTAG_KERNEL_DEBUG \
 	BUILD_EPITTCP
diff -Nur bcm963xx_router.orig/targets/96348GWV_DT/96348GWV_DT bcm963xx_router/targets/96348GWV_DT/96348GWV_DT
--- bcm963xx_router.orig/targets/96348GWV_DT/96348GWV_DT	2006-05-15 16:49:42.000000000 +0200
+++ bcm963xx_router/targets/96348GWV_DT/96348GWV_DT	2007-12-17 09:02:49.000000000 +0100
@@ -107,8 +107,10 @@
 BUILD_DHCPR=dynamic
 BUILD_UPNP=dynamic
 BUILD_BUSYBOX=dynamic
+BUILD_THTTPD=dynamic
 # BUILD_FTPD is not set
 BUILD_ATMCTL=dynamic
+BUILD_DROPBEAR=dynamic
 BUILD_ADSLCTL=dynamic
 BUILD_NETCTL=dynamic
 BUILD_WLCTL=dynamic
diff -Nur bcm963xx_router.orig/targets/buildFS bcm963xx_router/targets/buildFS
--- bcm963xx_router.orig/targets/buildFS	2006-01-25 04:56:29.000000000 +0100
+++ bcm963xx_router/targets/buildFS	2007-12-17 09:02:49.000000000 +0100
@@ -91,4 +91,7 @@
 echo "Stripping userapps and shared libraries more..."
 $SSTRIP $TOP_DIR/$ROOTFS/bin/* $TOP_DIR/$ROOTFS/lib/*.so*
 
-
+# Symlinks for dropbear
+#ln -s $TOP_DIR/$ROOTFS/bin/dropbearmulti $TOP_DIR/$ROOTFS/bin/dropbear
+#ln -s $TOP_DIR/$ROOTFS/bin/dropbearmulti $TOP_DIR/$ROOTFS/bin/dropbearkey
+#ln -s $TOP_DIR/$ROOTFS/bin/dropbearmulti $TOP_DIR/$ROOTFS/bin/dropbearconvert
diff -Nur bcm963xx_router.orig/targets/fs.src/etc/fstab bcm963xx_router/targets/fs.src/etc/fstab
--- bcm963xx_router.orig/targets/fs.src/etc/fstab	2006-01-25 04:56:29.000000000 +0100
+++ bcm963xx_router/targets/fs.src/etc/fstab	2007-12-17 09:02:49.000000000 +0100
@@ -1,3 +1,2 @@
 proc		/proc	proc	defaults    0	0
 tmpfs           /var    tmpfs   size=256k    0   0
-
diff -Nur bcm963xx_router.orig/targets/fs.src/etc/init.d/rcS bcm963xx_router/targets/fs.src/etc/init.d/rcS
--- bcm963xx_router.orig/targets/fs.src/etc/init.d/rcS	2006-01-25 04:56:29.000000000 +0100
+++ bcm963xx_router/targets/fs.src/etc/init.d/rcS	2007-12-17 09:02:49.000000000 +0100
@@ -5,4 +5,26 @@
 
 mount -t proc proc /proc
 /bin/mount -a
-#/sbin/inetd
\ Kein Zeilenumbruch am Dateiende.
+
+# cron daemon
+
+mkdir -p /var/spool/cron/crontabs
+
+# Disconnect um 4 Uhr nachts
+
+echo "0 4 * * * /usr/bin/wget -O /dev/null http://\`ifconfig br0 | sed -n '/inet addr/p' | sed -e 's/^ *inet addr://' -e 's/ .*\$//'\`/cgi-bin/disconnect.exe" > /var/spool/cron/crontabs/root
+
+/usr/sbin/crond
+
+/sbin/board_control start
+
+# Create SymLink for http additional features
+
+mkdir -p /var/www
+ln -s /www81/index.cgi /var/www/idx81.cgi
+echo "#!/bin/sh" > /var/www/index.cgi
+echo "" >> /var/www/index.cgi
+echo ". idx81.cgi" >> /var/www/index.cgi
+chmod 755 /var/www/index.cgi
+
+/sbin/thttpd_wrapper &
diff -Nur bcm963xx_router.orig/targets/makeDevs bcm963xx_router/targets/makeDevs
--- bcm963xx_router.orig/targets/makeDevs	2006-01-25 04:56:29.000000000 +0100
+++ bcm963xx_router/targets/makeDevs	2007-12-17 09:02:49.000000000 +0100
@@ -63,3 +63,19 @@
 mknod $ROOTFS/dev/mtdblock5 b 31 5
 mknod $ROOTFS/dev/mtdblock6 b 31 6
 mknod $ROOTFS/dev/mtdblock7 b 31 7
+
+# Create ttyp* and ptyp* for dropbear
+
+mknod $ROOTFS/dev/ptyp0 c 2 0
+mknod $ROOTFS/dev/ptyp1 c 2 1
+mknod $ROOTFS/dev/ptyp2 c 2 2
+mknod $ROOTFS/dev/ptyp3 c 2 3
+mknod $ROOTFS/dev/ttyp0 c 3 0
+mknod $ROOTFS/dev/ttyp1 c 3 1
+mknod $ROOTFS/dev/ttyp2 c 3 2
+mknod $ROOTFS/dev/ttyp3 c 3 3
+
+# Create random devices
+
+mknod $ROOTFS/dev/random c 1 8
+mknod $ROOTFS/dev/urandom c 1 9
diff -Nur bcm963xx_router.orig/userapps/broadcom/adslctl/Makefile bcm963xx_router/userapps/broadcom/adslctl/Makefile
--- bcm963xx_router.orig/userapps/broadcom/adslctl/Makefile	2007-08-23 05:15:15.000000000 +0200
+++ bcm963xx_router/userapps/broadcom/adslctl/Makefile	2007-12-17 09:02:49.000000000 +0100
@@ -1,5 +1,6 @@
 all:
 	cp adslctl_$(PROFILE)_save adslctl
+	cp adslctl2_$(PROFILE)_save adslctl2
 
 PROGRAM_NAME:=adslctl
 
@@ -7,9 +8,13 @@
 	install -m 755 $(PROGRAM_NAME) $(INSTALL_DIR)/bin
 	$(STRIP) $(INSTALL_DIR)/bin/$(PROGRAM_NAME)
 	ln -sf $(PROGRAM_NAME) $(INSTALL_DIR)/bin/adsl
+	install -m 755 $(PROGRAM_NAME)2 $(INSTALL_DIR)/bin
+	$(STRIP) $(INSTALL_DIR)/bin/$(PROGRAM_NAME)2
+	ln -sf $(PROGRAM_NAME)2 $(INSTALL_DIR)/bin/adsl2
 
 dynamic: all install
 
 clean:
 	rm -f adslctl
+	rm -f adslctl2
 
diff -Nur bcm963xx_router.orig/userapps/broadcom/cfm/inc/version.h bcm963xx_router/userapps/broadcom/cfm/inc/version.h
--- bcm963xx_router.orig/userapps/broadcom/cfm/inc/version.h	2007-08-23 05:06:45.000000000 +0200
+++ bcm963xx_router/userapps/broadcom/cfm/inc/version.h	2007-12-17 09:02:49.000000000 +0100
@@ -1,4 +1,4 @@
-#define SOFTWARE_VERSION "TARGA.0.13v1.300L01.V27.sip.faxr.LE9500"
-#define RELEASE_VERSION "TARGA.0.13v1.300L01.V27.sip.faxr.LE9500"
+#define SOFTWARE_VERSION "DA2401.1.00v1.300L01.V27.sip.faxr.LE9500"
+#define RELEASE_VERSION "DA2401.1.00v1.300L01.V27.sip.faxr.LE9500"
 #define PSI_VERSION ""
 #define FW_VERSION "300L01.V27"
diff -Nur bcm963xx_router.orig/userapps/broadcom/dropbear/index.cgi bcm963xx_router/userapps/broadcom/dropbear/index.cgi
--- bcm963xx_router.orig/userapps/broadcom/dropbear/index.cgi	2007-11-12 03:06:17.000000000 +0100
+++ bcm963xx_router/userapps/broadcom/dropbear/index.cgi	2007-12-17 09:02:49.000000000 +0100
@@ -11,7 +11,7 @@
 
 if [ "$REQUEST_METHOD" = "GET" ] ; then
 
-  # Called from Side Menu
+  # Mozilla: Called from Side Menu
   # So "http://" + $HTTP_HOST + "/m_startseite.htm"
   # must be equal to $HTTP_REFERER
 
@@ -20,6 +20,15 @@
     AUTHENTICATE="1"
   fi
 
+  # IE: Called from top_start_passwort.htm
+  # So "http://" + $HTTP_HOST + "/top_start_passwort.htm"
+  # must be equal to $HTTP_REFERER
+
+  CHECKHOST="http://"$HTTP_HOST"/top_start_passwort.htm"
+  if [ "$CHECKHOST" = "$HTTP_REFERER" ] ; then
+    AUTHENTICATE="1"
+  fi
+
 else
 
   #
@@ -255,7 +264,12 @@
 echo 'top.frames[2].location.href = "http://'"$HTTP_HOST"'/hcti_startseite.htm";'
 echo '}'
 
-cat << EOF
+#
+# Cat til EOF only transfers a few lines if used by IE
+# So transfer will be divided into three parts
+#
+
+cat << EINSEOF
 
 function frmLoad() {
   if (takt=='Ja') {
@@ -373,6 +387,10 @@
 <DIV id=c_pfad>Additional Features</DIV>
 <DIV id=c_titel>Aktionen bei Routerneustart</DIV>
 
+EINSEOF
+
+cat << ZWEIEOF
+
 <DIV id=c_std>
       <table border="0" cellpadding="0" cellspacing="2">
         <tr onmouseover=i_showElem(1) onmouseout=i_showElem(0)>
@@ -462,6 +480,11 @@
      Wenn Sie die Option 'Aus' markieren, wird Telnet beim n&auml;chsten Routerstart nicht mehr gestartet.</p>
     <p>Sollte die Secure Shell deaktiviert sein, ist Telnet automatisch immer aktiv.</p>
   </DIV>
+
+ZWEIEOF
+
+cat << DREIEOF
+
   <DIV id=i_content2>
     <h2>Aktionen bei Routerstart</h2>
     <p><b>Secure Shell (SSH)</b><br>
@@ -488,7 +511,7 @@
   </DIV>
 </DIV></BODY></HTML>
 
-EOF
+DREIEOF
 
 fi
 fi
diff -Nur bcm963xx_router.orig/userapps/opensource/busybox/brcm.config bcm963xx_router/userapps/opensource/busybox/brcm.config
--- bcm963xx_router.orig/userapps/opensource/busybox/brcm.config	2006-01-25 04:58:05.000000000 +0100
+++ bcm963xx_router/userapps/opensource/busybox/brcm.config	2007-12-17 09:02:49.000000000 +0100
@@ -9,13 +9,15 @@
 # CONFIG_FEATURE_BUFFERS_USE_MALLOC is not set
 CONFIG_FEATURE_BUFFERS_GO_ON_STACK=y
 # CONFIG_FEATURE_BUFFERS_GO_IN_BSS is not set
-CONFIG_FEATURE_VERBOSE_USAGE=y
+# CONFIG_FEATURE_VERBOSE_USAGE is not set
 # CONFIG_FEATURE_INSTALLER is not set
 # CONFIG_LOCALE_SUPPORT is not set
 # CONFIG_FEATURE_DEVFS is not set
 # CONFIG_FEATURE_DEVPTS is not set
 # CONFIG_FEATURE_CLEAN_UP is not set
-# CONFIG_FEATURE_SUID is not set
+CONFIG_FEATURE_SUID=y
+CONFIG_FEATURE_SUID_CONFIG=y
+CONFIG_FEATURE_SUID_CONFIG_QUIET=y
 # CONFIG_SELINUX is not set
 
 #
@@ -24,7 +26,7 @@
 # CONFIG_STATIC is not set
 # CONFIG_LFS is not set
 USING_CROSS_COMPILER=y
-CROSS_COMPILER_PREFIX="/opt/toolchains_3_04/uclibc-crosstools/bin/mips-linux-uclibc-"
+CROSS_COMPILER_PREFIX="/opt/toolchains/uclibc-crosstools/bin/mips-linux-uclibc-"
 EXTRA_CFLAGS_OPTIONS=""
 
 #
@@ -41,13 +43,27 @@
 # CONFIG_CPIO is not set
 # CONFIG_DPKG is not set
 # CONFIG_DPKG_DEB is not set
-# CONFIG_GUNZIP is not set
-# CONFIG_GZIP is not set
+CONFIG_GUNZIP=y
+# CONFIG_FEATURE_GUNZIP_UNCOMPRESS is not set
+CONFIG_GZIP=y
 # CONFIG_RPM2CPIO is not set
 # CONFIG_RPM is not set
-# CONFIG_TAR is not set
+CONFIG_TAR=y
+CONFIG_FEATURE_TAR_CREATE=y
+# CONFIG_FEATURE_TAR_BZIP2 is not set
+# CONFIG_FEATURE_TAR_FROM is not set
+CONFIG_FEATURE_TAR_GZIP=y
+# CONFIG_FEATURE_TAR_COMPRESS is not set
+# CONFIG_FEATURE_TAR_OLDGNU_COMPATABILITY is not set
+CONFIG_FEATURE_TAR_GNU_EXTENSIONS=y
+# CONFIG_FEATURE_TAR_LONG_OPTIONS is not set
 # CONFIG_UNCOMPRESS is not set
-# CONFIG_UNZIP is not set
+CONFIG_UNZIP=y
+
+#
+# Common options for cpio and tar
+#
+# CONFIG_FEATURE_UNARCHIVE_TAPE is not set
 
 #
 # Coreutils
@@ -56,14 +72,15 @@
 # CONFIG_CAL is not set
 CONFIG_CAT=y
 # CONFIG_CHGRP is not set
-# CONFIG_CHMOD is not set
+CONFIG_CHMOD=y
 # CONFIG_CHOWN is not set
 # CONFIG_CHROOT is not set
 # CONFIG_CMP is not set
-# CONFIG_CP is not set
-# CONFIG_CUT is not set
-# CONFIG_DATE is not set
-# CONFIG_DD is not set
+CONFIG_CP=y
+CONFIG_CUT=y
+CONFIG_DATE=y
+CONFIG_FEATURE_DATE_ISOFMT=y
+CONFIG_DD=y
 CONFIG_DF=y
 # CONFIG_DIRNAME is not set
 # CONFIG_DOS2UNIX is not set
@@ -83,7 +100,7 @@
 # CONFIG_ID is not set
 # CONFIG_INSTALL is not set
 # CONFIG_LENGTH is not set
-# CONFIG_LN is not set
+CONFIG_LN=y
 # CONFIG_LOGNAME is not set
 CONFIG_LS=y
 CONFIG_FEATURE_LS_FILETYPES=y
@@ -97,13 +114,13 @@
 CONFIG_MKDIR=y
 # CONFIG_MKFIFO is not set
 # CONFIG_MKNOD is not set
-# CONFIG_MV is not set
+CONFIG_MV=y
 # CONFIG_OD is not set
 # CONFIG_PRINTF is not set
 CONFIG_PWD=y
 # CONFIG_REALPATH is not set
 CONFIG_RM=y
-# CONFIG_RMDIR is not set
+CONFIG_RMDIR=y
 # CONFIG_SEQ is not set
 # CONFIG_SHA1SUM is not set
 # CONFIG_SLEEP is not set
@@ -118,7 +135,7 @@
 # test (forced enabled for use with shell)
 #
 # CONFIG_FEATURE_TEST_64 is not set
-# CONFIG_TOUCH is not set
+CONFIG_TOUCH=y
 # CONFIG_TR is not set
 CONFIG_TRUE=y
 
@@ -138,6 +155,11 @@
 # CONFIG_YES is not set
 
 #
+# Common options for cp and mv
+#
+# CONFIG_FEATURE_PRESERVE_HARDLINKS is not set
+
+#
 # Common options for ls and more
 #
 CONFIG_FEATURE_AUTOWIDTH=y
@@ -176,13 +198,26 @@
 # CONFIG_AWK is not set
 # CONFIG_PATCH is not set
 CONFIG_SED=y
-# CONFIG_VI is not set
+CONFIG_VI=y
+CONFIG_FEATURE_VI_COLON=y
+CONFIG_FEATURE_VI_YANKMARK=y
+CONFIG_FEATURE_VI_SEARCH=y
+CONFIG_FEATURE_VI_USE_SIGNALS=y
+CONFIG_FEATURE_VI_DOT_CMD=y
+CONFIG_FEATURE_VI_READONLY=y
+CONFIG_FEATURE_VI_SETOPTS=y
+CONFIG_FEATURE_VI_SET=y
+CONFIG_FEATURE_VI_WIN_RESIZE=y
+CONFIG_FEATURE_VI_OPTIMIZE_CURSOR=y
 
 #
 # Finding Utilities
 #
 # CONFIG_FIND is not set
-# CONFIG_GREP is not set
+CONFIG_GREP=y
+CONFIG_FEATURE_GREP_EGREP_ALIAS=y
+CONFIG_FEATURE_GREP_FGREP_ALIAS=y
+CONFIG_FEATURE_GREP_CONTEXT=y
 # CONFIG_XARGS is not set
 
 #
@@ -207,17 +242,25 @@
 # CONFIG_ADDUSER is not set
 # CONFIG_DELUSER is not set
 # CONFIG_GETTY is not set
-# CONFIG_LOGIN is not set
+# CONFIG_FEATURE_U_W_TMP is not set
+CONFIG_LOGIN=y
+CONFIG_FEATURE_SECURETTY=y
 # CONFIG_PASSWD is not set
 # CONFIG_SU is not set
 # CONFIG_SULOGIN is not set
 # CONFIG_VLOCK is not set
 
 #
+# Common options for adduser, deluser, login, su
+#
+# CONFIG_FEATURE_SHADOWPASSWDS is not set
+
+#
 # Miscellaneous Utilities
 #
 # CONFIG_ADJTIMEX is not set
-# CONFIG_CROND is not set
+CONFIG_CROND=y
+# CONFIG_FEATURE_CROND_CALL_SENDMAIL is not set
 # CONFIG_CRONTAB is not set
 # CONFIG_DC is not set
 # CONFIG_DEVFSD is not set
@@ -237,7 +280,7 @@
 CONFIG_INSMOD=y
 # CONFIG_FEATURE_2_4_MODULES is not set
 CONFIG_FEATURE_2_6_MODULES=y
-# CONFIG_LSMOD is not set
+CONFIG_LSMOD=y
 # CONFIG_MODPROBE is not set
 CONFIG_RMMOD=y
 # CONFIG_FEATURE_CHECK_TAINTED_MODULE is not set
@@ -268,22 +311,27 @@
 # CONFIG_IPROUTE is not set
 # CONFIG_IPTUNNEL is not set
 # CONFIG_NAMEIF is not set
-# CONFIG_NC is not set
-# CONFIG_NETSTAT is not set
-# CONFIG_NSLOOKUP is not set
+CONFIG_NC=y
+CONFIG_NETSTAT=y
+CONFIG_NSLOOKUP=y
 CONFIG_PING=y
 # CONFIG_FEATURE_FANCY_PING is not set
 CONFIG_ROUTE=y
 # CONFIG_TELNET is not set
-# CONFIG_TELNETD is not set
+CONFIG_TELNETD=y
+# CONFIG_FEATURE_TELNETD_INETD is not set
 CONFIG_TFTP=y
 CONFIG_FEATURE_TFTP_GET=y
 CONFIG_FEATURE_TFTP_PUT=y
 # CONFIG_FEATURE_TFTP_BLOCKSIZE is not set
 # CONFIG_FEATURE_TFTP_DEBUG is not set
-# CONFIG_TRACEROUTE is not set
+CONFIG_TRACEROUTE=y
+# CONFIG_FEATURE_TRACEROUTE_VERBOSE is not set
 CONFIG_VCONFIG=y
-# CONFIG_WGET is not set
+CONFIG_WGET=y
+# CONFIG_FEATURE_WGET_STATUSBAR is not set
+CONFIG_FEATURE_WGET_AUTHENTICATION=y
+# CONFIG_FEATURE_WGET_IP6_LITERAL is not set
 
 #
 # udhcp Server/Client
@@ -297,11 +345,11 @@
 # CONFIG_FREE is not set
 CONFIG_KILL=y
 # CONFIG_KILLALL is not set
-# CONFIG_PIDOF is not set
+CONFIG_PIDOF=y
 CONFIG_PS=y
 # CONFIG_RENICE is not set
 # CONFIG_TOP is not set
-# CONFIG_UPTIME is not set
+CONFIG_UPTIME=y
 # CONFIG_SYSCTL is not set
 
 #
@@ -320,11 +368,12 @@
 #
 # Bourne Shell Options
 #
-# CONFIG_FEATURE_SH_EXTRA_QUIET is not set
+CONFIG_FEATURE_SH_EXTRA_QUIET=y
 CONFIG_FEATURE_SH_STANDALONE_SHELL=y
 CONFIG_FEATURE_COMMAND_EDITING=y
 CONFIG_FEATURE_COMMAND_HISTORY=15
-# CONFIG_FEATURE_COMMAND_TAB_COMPLETION is not set
+CONFIG_FEATURE_COMMAND_TAB_COMPLETION=y
+# CONFIG_FEATURE_COMMAND_USERNAME_COMPLETION is not set
 # CONFIG_FEATURE_SH_FANCY_PROMPT is not set
 
 #
@@ -362,7 +411,8 @@
 # CONFIG_SWAPONOFF is not set
 CONFIG_MOUNT=y
 # CONFIG_NFSMOUNT is not set
-# CONFIG_UMOUNT is not set
+CONFIG_UMOUNT=y
+# CONFIG_FEATURE_MOUNT_FORCE is not set
 
 #
 # Common options for mount/umount
diff -Nur bcm963xx_router.orig/version.make bcm963xx_router/version.make
--- bcm963xx_router.orig/version.make	2006-08-23 05:40:30.000000000 +0200
+++ bcm963xx_router/version.make	2007-12-17 09:02:49.000000000 +0100
@@ -1,6 +1,6 @@
 # BRCM_VERSION=3
 # BRCM_RELEASE=00
 # BRCM_EXTRAVERSION=01V
-BRCM_VERSION=TARGA
-BRCM_RELEASE=0.13v1
+BRCM_VERSION=DA2401
+BRCM_RELEASE=1.00v1
 BRCM_EXTRAVERSION=300L01.V27
